//////////////////////////////////////////////////////////////////////
/*!	@class	AquesTalk

	@brief	KGW AquesTalk10

  L񂩂特g`f[^ɐ
  o͉g`́A16KHz, 16bit,m,WAVtH[}bgB
                  *TvOǵAp[^fscɂω

	@author	N.Yamazaki (AQUEST)

	@date	2017/10/27	N.Yamazaki	Creation for Win
*/
//////////////////////////////////////////////////////////////////////
#if !defined(_AQUESTALK10_H_)
#define _AQUESTALK10_H_
#ifdef __cplusplus
extern "C"{
#endif

// p[^
typedef struct _AQTK_VOICE_ {
	int bas;	// {f F1E/F2E/M1E (0/1/2)
	int spd;	// b 	50-300 default:100
	int vol;	//  	0-300 default:100
	int pit;	//  	20-200 default:{fЂɈˑ
	int acc;	// ANZg 0-200 default:{fЂɈˑ
	int lmd;	// P 	0-200 default:100
	int fsc;	// Q(TvOg) 50-200 default:100
} AQTK_VOICE;

enum VoiceBase { F1E =0, F2E, M1E }; // {f

// vZbg                 bas  spd  vol  pit  acc  lmd  fsc
const AQTK_VOICE	gVoice_F1 = { F1E, 100, 100, 100, 100, 100, 100}; //  F1
const AQTK_VOICE	gVoice_F2 = { F2E, 100, 100,  77, 150, 100, 100}; //  F2
const AQTK_VOICE	gVoice_F3 = { F1E,  80, 100, 100, 100,  61, 148}; //  F3
const AQTK_VOICE	gVoice_M1 = { M1E, 100, 100,  30, 100, 100, 100}; // j M1
const AQTK_VOICE	gVoice_M2 = { M1E, 105, 100,  45, 130, 120, 100}; // j M2
const AQTK_VOICE	gVoice_R1 = { M1E, 100, 100,  30,  20, 190, 100}; // {bg R1
const AQTK_VOICE	gVoice_R2 = { F2E,  70, 100,  50,  50,  50, 180}; // {bg R2


/////////////////////////////////////////////
//!	L񂩂特g`𐶐
//!	g`f[^͓ŗ̈mۂB
//!	g`f[^͖̉{֐̌ĂяoAquesTalk_FreeWave()ɂčs
//!
//! @param	pParam[in]	p[^ (AQTK_VOICE\̂̃AhX)
//! @param	koe[in]		LiSJIS NULLI[j
//!	@param	pSize[out]	f[^̃TCY[byte]iG[̏ꍇ̓G[R[hԂj
//!	@return	WAVtH[}bg̉f[^̐擪AhXBG[NULLԂ
unsigned char * __stdcall AquesTalk_Synthe(const AQTK_VOICE *pParam, const char *koe, int *pSize);

//! @param	koe[in]		LiUTF8 NULLI[ BOMj
unsigned char * __stdcall AquesTalk_Synthe_Utf8(const AQTK_VOICE *pParam, const char *koe, int *pSize);

//! @param	koe[in]		LiUTF16 NULLI[ BOM̗L͖Ȃ@GfBA͎sɏ]j
unsigned char * __stdcall AquesTalk_Synthe_Utf16(const AQTK_VOICE *pParam, const unsigned short *koe, int *pSize);


/////////////////////////////////////////////
//!	f[^̗̈J
//!	@param  wav[in]		AquesTalk_Synthe()ŕԂꂽAhXw
void __stdcall AquesTalk_FreeWave(unsigned char *wav);


/////////////////////////////////////////////
//!	JCZXL[ݒ
//!	g`𐶐OɈxĂяoB
//!	ɂ]ł̐ȂȂB
//!	@param  key[in]		CZXL[w
//!	@return	CZXL[0AȂ1Ԃ
//! *L[̉͂hߕsȃL[ł0ԂꍇB̂Ƃ͉ȂB
int __stdcall AquesTalk_SetDevKey(const char *key);

/////////////////////////////////////////////
//!	gpCZXL[ݒ
//!	g`𐶐OɈxĂяoB
//!	ȍ~Af[^Ɋ܂܂铧AgpCZX擾ς݂ɕω
//!	@param  key[in]		CZXL[w
//!	@return	CZXL[0AȂ1Ԃ
//! *L[̉͂hߕsȃL[ł0ԂꍇB̏ꍇACZX̂܂܂łB
int __stdcall AquesTalk_SetUsrKey(const char *key);

#ifdef __cplusplus
}
#endif
#endif // !defined(_AQUESTALK10_H_)
//  ----------------------------------------------------------------------
// !  Copyright AQUEST Corp. 2006- .  All Rights Reserved.                !
// !  An unpublished and CONFIDENTIAL work.  Reproduction, adaptation, or !
// !  translation without prior written permission is prohibited except   !
// !  as allowed under the copyright laws.                                !
//  ----------------------------------------------------------------------
